{
  gROOT->Macro("start.C"); 
  gROOT->LoadMacro("Legal.C");
  TFile RunDep("../RunDep.root");
  TFile O80("../Output80.root");
  TFile O95("../Output95.root");
  RunDepCor* R80=RunDep->Get("RDC12080001");
  RunDepCor* R95=RunDep->Get("RDC12095006");
  TObjArray* m80=((TObjArray*) O80->Get("Mycells"));
  TObjArray* m95=((TObjArray*) O95->Get("Mycells"));
  Int_t nrows[4]={34,34,24,24};
  Int_t nstb=4;
  Int_t row=10;
  Int_t col=8;
  TGraphErrors* gr=new TGraphErrors();
  for(row=0;row<nrows[nstb];row++)
    {
      for(col=0;col<nrows[nstb-1]/2;col++)
	{
	  if(Legal(2,nstb,row,col))
	    {
	      CellTDep* ct80=0;
	      CellTDep* ct95=0;
	      ct80=R80->Cdep(nstb,row,col);
	      ct95=R95->Cdep(nstb,row,col);
	      Float_t led80=ct80->GetthisLedADC();
	      Float_t led95=ct95->GetthisLedADC();
	      char nam[200];
	      sprintf(nam,"Cellr%d_c%d_%d",row,col,nstb-1);
	      printf("%s \n",nam);
	      Float_t Meanadc80=((Cell*) m80->FindObject(nam))->p_adc->GetMean();

	      Float_t ErMeanadc80=((Cell*) m80->FindObject(nam))->p_adc->GetMeanError();
	      Float_t Meanadc95=((Cell*) m95->FindObject(nam))->p_adc->GetMean();
	      Float_t ErMeanadc95=((Cell*) m95->FindObject(nam))->p_adc->GetMeanError();
	      printf("led80=%f led95=%f Meanadc80=%f Meanadc95=%f \n",led80,led95,Meanadc80,Meanadc95);
	      int cnt=gr->GetN();
	      if(led80!=0 && led95!=0 Meanadc80!=0 && Meanadc95!=0)
		{
		  Float_t lratio=led95/led80;
		  Float_t adcer=pow(ErMeanadc95/Meanadc95,2)+
		    pow(ErMeanadc80/Meanadc80,2);
		  adcer=sqrt(adcer);
		  Float_t Mratio=Meanadc95/Meanadc80;
		  if(fabs(lratio-1)<1 && fabs(Mratio-1.)<.3)
		    {
		      gr->SetPoint(cnt,lratio,Meanadc95/Meanadc80);
		      gr->SetPointError(cnt,0,adcer);
		    };
		};
	    };
	};
    };
  TGraphErrors* gg=new TGraphErrors(*gr);
  gg->SetTitle("ADC Gain vs LED Day95/Day80 NSTB=4"); 
  gg->GetXaxis()->SetTitle("LED95/LED80"); 
  gg->GetYaxis()->SetTitle("(ADC Mean95)/(ADC Mean80)"); 
  gg->Fit("pol1","","",.7,1.05);
  gg->Draw("A*");

}
