void GcUpdate(TString set="small")
{
  char history[200];
  char ehistory[200];
  char ghistory[200];

  sprintf(history,"%sPlots/history.ps",(char*) set);
  sprintf(ehistory,"%sPlots/ehistory.ps",(char*) set);
  sprintf(ghistory,"%sPlots/ghistory.ps",(char*) set);

  TString History=history;
  TString eHistory=ehistory;
  TString gHistory=ghistory;

  gROOT->LoadMacro("Legal.C");
  Int_t nstb0=1;
  if(set == TString("small"))nstb0=3;
  TString str1=gSystem->ExpandPathName("$SETFMSENV");
  TString ldpath=gSystem->ExpandPathName("${FMSSRC}/Fpdchan.so");
  if(str1!="SETFMSENV"){printf("source SetFMSEnv first");exit();};
  printf("loading %s \n",(char*) ldpath);
  gROOT->Reset();
  gSystem->Load("${FMSSRC}/Fpdchan.so");
  Int_t NROWS[4]={34,34,24,24};
  TFile* f0=new TFile("mvse.root","recreate");  
  TFile* Fpd=new TFile("FpdFile.root","UPDATE");
  gStyle->SetPalette(1);
  TCanvas* c2=new TCanvas("c2","c2",600,600);  
  TCanvas* c3=new TCanvas("c3","c3",600,600);
  TCanvas* c1=new TCanvas("c1","c1",600,600);
  Bool_t ReplaceFpd=false;
  if(Fpd)ReplaceFpd=true;
  int ver=1;  
  CalibStr* FpdCorr=0;
  CalibStr* FpdCnew=0;
  char strver[100];
  TGraph* fpgr[34][17][4];
  TGraph* cvar[34][17][4];
  TH2F* mvse[2000];
  int mcnt=0;
  for( int ns=nstb0-1;ns<nstb0+1;ns++)
    {
      for(int ro=0;ro<NROWS[ns];ro++)
	{
	  for(int co=0;co<NROWS[ns]/2;co++)
	    {
	      fpgr[ro][co][ns]=0;
	      cvar[ro][co][ns]=0;
	    }
	};
    };
  sprintf(strver,"%d",ver);
  while(FpdCnew=(CalibStr*) Fpd->Get(TString("FpdCorrV")+strver))
    {		
      printf("inter \n");
      FpdCorr=FpdCnew;
      FpdCorr->filename="FpdCorr.txt";
      FpdCorr->OutName="FpdCorr.txt";
      for( int ns=nstb0-1;ns<nstb0+1;ns++)
	{
	  for(int ro=0;ro<NROWS[ns];ro++)
	    {
	      for(int co=0;co<NROWS[ns]/2;co++)
		{
		  if(fpgr[ro][co][ns]==0)fpgr[ro][co][ns]=new TGraph();
		  int npt=fpgr[ro][co][ns]->GetN();
		  fpgr[ro][co][ns]->SetPoint(npt,ver,FpdCorr->GetValue(2,ns+1,ro,co));
		  
		  char str[100];
		  sprintf(str,"row_%d_col%d_d%d",ro,co,ns);
		  fpgr[ro][co][ns]->SetTitle(str);
		};
	    };
	};
      ver++;
      
      sprintf(strver,"%d",ver);
    };
  
  
  if(!FpdCorr)exit;
  c1->Divide(4,4);
  c1->Print(History+"(");
  int pd=0;
  
  for( int ns=nstb0-1;ns<nstb0+1;ns++)
    {
      for(int ro=0;ro<NROWS[ns];ro++)
	{
	  for(int co=0;co<NROWS[ns]/2;co++)
	    {
	      pd++;
	      if(pd>16)
		{
		  c1->Update();
		  c1->Print(History);
		  pd=1;
		};
	      c1->cd(pd);
	      fpgr[ro][co][ns]->GetYaxis()->SetRangeUser(0,3.);
	      if(Legal(2,ns+1,ro,co))
		{
		  fpgr[ro][co][ns]->Draw("A*");
		};
	    };
	};
    };
  c1->Clear();
  c1->Print(History+")");
  FitTower::Setwe_ab(0.8,.3,-.1,.8,.2,7.6);//Nominal Shower Shape
  Cell* cell[34][17][4];
  for(int nstb=1;nstb<5;nstb++)
    {
      for(int row=1;row<NROWS[nstb-1]+1;row++)
	{for(int col=1;col<NROWS[nstb-1]/2+1;col++)
	    {
	      cell[row-1][col-1][nstb-1]=0;
	    }
	};
    };
  TFile* fl0=new TFile("Output.root","Update");
  TObjArray* mycells=(TObjArray*)  fl0->FindKey("Mycells")->ReadObj();
  TIter next(mycells);
  Cell* c;
  TTree* atr=0;
  tpCellRec* rc=0;
  
  TH1F* edist=new TH1F("edist","edist",100,.0,100.);
  while(c=(Cell*) next())
    {
      if(c->Instb >=nstb0 &&c->Instb<=nstb0+1)
	{
	  edist->Reset();
	  printf("row=%d col=%d nstb=%d\n",c->Row1,c->Col1,c->Instb);
	  cell[c->Row1-1][c->Col1-1][c->Instb-1]=c;
	}
    };
  printf("stage 2\n");
  int pass=1;
  TH2F* pGCorr[4];
  //**************************
  Fpd->cd();
  TTree* gTr0=new TTree("gTr","gTr");
  
  Float_t gEn70;
  Float_t gDEn70;
  Float_t gMass;
  Float_t gDMass;
  Float_t gEta;
  Float_t gFn70;
  Float_t gRatio;
  Float_t gDRatio;
  Int_t gSet=3;
  Float_t gFM;
  Float_t gFS;
  Float_t gDFM;
  Float_t gDFS;
  Int_t Quality;
  Float_t Cor;
  Int_t nstb;
  Int_t row;
  Int_t col;
  Float_t Int65;
  
  gTr0->Branch("gEn70",&gEn70,"gEn70/F");
  gTr0->Branch("gDEn70",&gDEn70,"gDEn70/F");
  gTr0->Branch("gMass",&gMass,"gMass/F");
  gTr0->Branch("gDMass",&gDMass,"gDMass/F");
  gTr0->Branch("gEta",&gEta,"gEta/F");
  gTr0->Branch("gFn70",&gFn70,"gFn70/F");
  gTr0->Branch("gRatio",&gRatio,"gRatio/F");
  gTr0->Branch("gDRatio",&gDRatio,"gDRatio/F");
  gTr0->Branch("gSet",&gSet,"gSet/I");
  gTr0->Branch("gnstb",&nstb,"nstb/I");
  gTr0->Branch("grow",&row,"row/I");
  gTr0->Branch("gcol",&col,"col/I");
  gTr0->Branch("gQ",&Quality,"Q/I");
  gTr0->Branch("gCor",&Cor,"gCor/F");
  
  gTr0->Branch("gFM",&gFM,"gFM/F");
  gTr0->Branch("gFS",&gFS,"gFS");
  gTr0->Branch("gDFM",&gDFM,"gDFM/F");
  gTr0->Branch("gDFS",&gDFS,"gDFS");
  gTr0->Branch("gInt65",&Int65,"Int65/F"); 
  //****************************
  c3->Divide(4,4);
  c3->Print(gHistory+"(");
  c2->Divide(4,4);
  c2->Print(eHistory+"(");
  pd=0;
  for(int nstb=nstb0;nstb<nstb0+2;nstb++)
    {  
      char chns[100];
      sprintf(chns,"%d",nstb);
      TString GCorrName=TString("GCorr")+chns;
      Int_t nb=24;
      if(nstb<3)nb=34;
      
      pGCorr[nstb-1]=new TH2F(GCorrName,GCorrName,nb/2,0,nb/2,nb,0,nb);  
      for(Int_t ro=1;ro<NROWS[nstb-1]+1;ro++)
	{
	  printf("ro=%d\n",ro);
	  for(int col=1;col<NROWS[nstb-1]/2+1;col++)
	    {
	      printf("loop ro= %d col=%d nstb %d \n",ro,col,nstb);
	      c=cell[ro-1][col-1][nstb-1];
	      if(!c)
		{
		  printf("c not defined\n");
		}
	      else
		{
		  TString fname("data2/");
		  fname=fname+"_"+c->GetName()+".root";
		  printf(" %s\n",(const char*)fname);
		  TFile fl(fname,"read");
		  if(fl.IsOpen())
		    {
		      printf("open\n");
		      TGraph* pGr0=(TGraph*) fl.Get("Gr0");
		      if(pGr0)
			{
			  printf("found\n");
			  int nbins=0;
			  if((nbins=pGr0->GetN())>0)
			    {
			      printf("nbins=%d\n",nbins);
			      Float_t factor=pGr0->GetY()[nbins-1];
			      Float_t xx=1.*col-.5;
			      Float_t yy=1.*row-.5;
			      printf("r=%d c=%d n=%d  f=%f xx=%f yy=%f \n",
				     ro,col,nstb,factor,xx,yy);
			      Int_t binN=pGCorr[nstb-1]->FindBin(1.*col-.5,1.*ro-.5);
			      pGCorr[nstb-1]->SetBinContent(binN,factor);
			    };
			};
		      //***************
		      TTree* gTr=(TTree*) fl.Get("gTr");
		      if(gTr)
			{
			  gTr->SetBranchAddress("gEn70",&gEn70);
			  gTr->SetBranchAddress("gDEn70",&gDEn70);
			  gTr->SetBranchAddress("gMass",&gMass);
			  gTr->SetBranchAddress("gDMass",&gDMass);
			  gTr->SetBranchAddress("gEta",&gEta);
			  gTr->SetBranchAddress("gFn70",&gFn70);
			  gTr->SetBranchAddress("gRatio",&gRatio);
			  gTr->SetBranchAddress("gDRatio",&gDRatio);
			  gTr->SetBranchAddress("gSet",&gSet);
			  gTr->SetBranchAddress("gnstb",&nstb);
			  gTr->SetBranchAddress("grow",&row);
			  gTr->SetBranchAddress("gcol",&col);
			  gTr->SetBranchAddress("gQ",&Quality);
			  gTr->SetBranchAddress("gCor",&Cor);
			  gTr->SetBranchAddress("gFM",&gFM);
			  gTr->SetBranchAddress("gFS",&gFS);
			  gTr->SetBranchAddress("gDFM",&gDFM);
			  gTr->SetBranchAddress("gDFS",&gDFS); 
			  gTr->SetBranchAddress("gInt65",&Int65);
			  int ngTr=gTr->GetEntries();
			  if(ngTr>0)
			    {
			      pd++;
			      mcnt++;
			      mvse[mcnt]=(TH2F*) fl.Get("mvse");
			      if(mvse[mcnt])
				{
				  char smcnt[200];
				  sprintf(smcnt,"mvse_%s",(char*) c->GetName());
				  f0->cd();
				  mvse[mcnt]->SetName(smcnt);
				  TString ntitle=mvse[mcnt]->GetTitle();
				  ntitle=ntitle+smcnt;
				  mvse[mcnt]->SetTitle(ntitle);
				  
				  printf(":mvse found\n");
				  
				  mvse[mcnt]->Write(smcnt);
				}
			      else
				{
				  printf(":mvse not found\n");
				}
			      fl.cd();
			      printf("pd=%d \n",pd);
			      if(pd>16)
				{
				  c3->Update();
				  c3->Print(gHistory);
				  c2->Update();
				  c2->Print(eHistory);
				  pd=1;
				};
			      c2->cd(pd);
			      cvar[ro-1][col-1][nstb-1]=new TGraph();
			      char chcvar[100];
			      sprintf(chcvar,"row0_%d_col0_%d_nstb0=%d",
				      ro-1,col-1,nstb-1);
			      cvar[ro-1][col-1][nstb-1]->SetTitle(chcvar);
			      //			      for(int ing=0;ing<ngTr;ing++)
			      for(int ing=ngTr-1;ing<ngTr;ing++)
				{
				  gTr->GetEntry(ing);
				  printf("ro=%d col=%d nstb=%d ngTr=%d gEn70=%f \n",ro,col,nstb,ngTr,gEn70);
				  gSet=ing;
				  cvar[ro-1][col-1][nstb-1]->SetMaximum(10.);
				  cvar[ro-1][col-1][nstb-1]->SetMinimum(.001);
				  
				  cvar[ro-1][col-1][nstb-1]->SetPoint(ing,gSet,gEn70);
				  
				  gTr0->Fill();
				};
			      cvar[ro-1][col-1][nstb-1]->Print();;
			      if(Legal(2,nstb,ro-1,col-1))
				{
				  c3->cd(pd);
				  Float_t ymin=.5;
				  Float_t ymax=1.5;
				  if(pGr0)
				    {
				      if(pGr0->GetN()>0)
					{
					  Float_t ylast=pGr0->GetY()[pGr0->GetN()-1];
					  if(ylast>ymax)ymax=ylast+.5;
					  if(ylast<ymin)ymin=ylast-.5;
					};
				      pGr0->GetYaxis()->SetRangeUser(ymin,ymax);
				      pGr0->Draw("A*");
				    }
				  c2->cd(pd);
				  cvar[ro-1][col-1][nstb-1]->Draw("A*");
				};
			      delete gTr;
			    };
			};
		      //**************
		      fl.Close();
		    };
		};
	    };
	};
      c2->Update();
      c3->Update();
      c2->Print(eHistory);
      c3->Print(ghistory);
      c1->cd();
      TH2F* GCorr=pGCorr[nstb-1];
      GCorr->SetMinimum(.9);
      GCorr->SetMaximum(1.1);
      GCorr->SetStats(0);
      GCorr->Draw("zcol");
      GCorr->SetMarkerSize(.8);
      GCorr->Draw("sametext");
      c1->Update();
      char ffname[100];
      sprintf(ffname,"Progress%d.pdf",nstb);
      cout<<"Now Print "<<ffname<<"\n";
      c1->Print(ffname);
      printf("pass %d done\n",pass);
    }
  Fpd->cd();
  gTr0->Write("gTr");
  Fpd->Purge();
  Fpd->Close();
  c3->Print(gHistory+")");
  c2->cd();
  c2->Print(eHistory+")");
  char cmdstr[200];
  sprintf(cmdstr,"cd %sPlots;ps2pdf history.ps;ps2pdf ehistory.ps;ps2pdf ghistory.ps;rm *.ps",(char*) set);
  printf("%s \n",cmdstr);
  system(cmdstr);
};
