{ 

  /*
    -Read through omg4.csv spreadsheet and creat a sheet object for each line.
    -Add a nominal SheetHistory to each Sheet
    -All Sheet in a TObjArray in tmp.root
    -Read through the Cells online
    -Preset gcorr in history from Cells
    -Make 6 High Voltage Set Files based on this
   */
  TString str=gSystem->ExpandPathName("$SETFMSENV");
  if(str!="SETFMSENV"){printf("source SetFMSEnv first");exit();};
  
  gROOT->Reset();
  gSystem->Load("${FMSSRC}/Fpdchan.so");
  TFile* HvGr=new TFile("HvGr.root");
  TFile tmp("tmp.root","recreate");
  FILE* fp;
  fp=fopen("omg3.csv","r");
  char hline[2000];
  char line[2000];
  TObjArray* ar=new TObjArray(2000,0);
  ar->IsOwner();
  if(!feof(fp))
    {

      fgets(hline,1999,fp);


    };

  while(!feof(fp))
    {
      fgets(line,1999,fp);
      //      cout<<"head="<<hline<<"\n";
      //      cout<<"line="<<line<<"\n";
      Sheet* sh=new Sheet(hline,line);
      sh->AddHistory((Float_t) sh->HVsetValue,sh->HVsetValue,
		     sh->Run9Gain,sh->Run9Gain,0,0);
      sh->Print();
      cout<<sh->GetName()<<"\n";
      ar->Add(sh);
      if(HvGr)
	{
	  sh->AddGr(HvGr);
	};
    }
  tmp->cd();
  ar->Write("MySheet",TObjArray::kSingleKey);
  TIter next(ar);
  Sheet* psh;
  FILE* fp1;
  FILE* fp2;
  FILE* fp3;
  FILE* fp4;
  FILE* fp5;
  FILE* fp6;
  
  fp1=fopen("HV1.set","w");
  fp2=fopen("HV2.set","w");
  fp3=fopen("HV3.set","w");
  fp4=fopen("HV4.set","w");
  fp5=fopen("HV5.set","w");
  fp6=fopen("HV6.set","w");
  

  while(psh=(Sheet*) next())
    {
      char fname[200];
      char cname[200];
      sprintf(fname,"data2/_Cellr%d_c%d_%d.root",psh->myrow0,psh->mycol0,psh->nstb1-1);
      sprintf(cname,"Cellr%d_c%d_%d",psh->myrow0,psh->mycol0,psh->nstb1-1);
      cout<<fname<<"\n";
      TFile fl(fname,"update");
      Cell* c=(Cell*) fl.Get(cname);
      if(c)
	{
	  (psh->GetHistory())->OldGcorr=c->gcorr;
	  (psh->GetHistory())->NewGcorr=c->gcorrNew;
	};
      psh->Write();
      fl.Purge();
      fl.Close();
      if(fabs(psh->HVfactor-1.)>.0001)
	{
	  if(psh->id1==7005)fprintf(fp1,"%s",(char*) psh->SetCommand(7)) ;
	  if(psh->id1==7006)fprintf(fp2,"%s",(char*) psh->SetCommand(7)) ;
	  if(psh->id1==7007)fprintf(fp3,"%s",(char*) psh->SetCommand(7)) ;
	  if(psh->id1==7008)fprintf(fp4,"%s",(char*) psh->SetCommand(7)) ;
	  if(psh->nstb1==3)fprintf(fp5,"%s",(char*) psh->SetCommand(6)) ;
	  if(psh->nstb1==4)fprintf(fp6,"%s",(char*) psh->SetCommand(6)) ;
	}
    };
}
