void RunSimple(char* name,int Begin=0,int set=0,int MaxRec=20000,Float_t gaincut=0.)
{
   TString str=gSystem->ExpandPathName("$SETFMSENV");
  if(str!="SETFMSENV"){printf("source SetFMSEnv first");exit();};
  
  gROOT->Reset();
  gSystem->Load("${FMSSRC}/Fpdchan.so");

  gROOT->LoadMacro("Legal.C");
  gROOT->LoadMacro("./SetFPD.C");
  gStyle->SetPalette(1);
  
   TString fna("data2/_");
  fna=fna+name+".root";
  // *************
  TFile fl(fna,"UPDATE");
  
 

  printf(" %s \n",name);
  TKey* key=fl.FindKey(name);
  if(!key)return;
  printf("reading key\n");
  Cell* c=(Cell*) key->ReadObj();
  TKey* keyRank=fl.FindKey("Rank");
  CalibStr* Rank=0;
  CalibStr* FpdGain=c->fpdgain;
  if(keyRank)Rank=(CalibStr*) keyRank->ReadObj();
  
  nstb=c->Instb;
  //use separate small and large shapes

   
  TCanvas* c1=new TCanvas("c1","c1",600,600);

  // ***********Fpd
  TFile* Fpd=new TFile("FpdFile.root","Read");

  Float_t Cor;
  int ver=1;  
  CalibStr* FpdCorr=0;
  CalibStr* FpdCnew=0;
  char strver[100];
  sprintf(strver,"%d",ver);
  while(FpdCnew=(CalibStr*) Fpd->Get(TString("FpdCorrV")+strver))
    {		
      FpdCorr=FpdCnew;
      FpdCorr->filename="FpdCorr.txt";
      FpdCorr->OutName="FpdCorr.txt";
      ver++;
      Float_t g=FpdCorr->GetValue(2,nstb,row-1,col-1);
      sprintf(strver,"%d",ver);
    };  
  Fpd->Close();
  fl.cd();
  FILE* fp=fopen("ChangeFpd.txt","r");
  char line[200];
  if(fp)
    {
      while(!feof(fp))
	{
	  if(fgets(line,100,fp))
	    {
	      Int_t ew,nst,ro,co;
	      Float_t val;
	      sscanf(line,"SetValue(%d,%d,%d,%d,%f)",&ew,&nst,&ro,&co,&val);
	      FpdCorr->SetValue(ew,nst,ro,co,val);
	    };
	};
      fclose(fp);
    }
  else
    {
      cout<<"ChangeFpd.txt not found\n";
    };
  SetFPD(FpdCorr);
  c->fpdcorr=FpdCorr;
  
  c->gcorr=c->gcorrNew;
  if(!c)printf("c not found\n");
  Bool_t lowcount=false;
  if(c->p_adc->Integral(10,1000)<50)lowcount=true;
  Int_T Ngt300=c->p_adc->Integral(300,1000).

  if(lowcount)
    {
      printf("too few  adc>10 hits\n");
    };
 


  c->gcorr=c->fpdcorr->GetValue(2,nstb,row-1,col-1);
  c->gcorrNew=c->gcorr*factor;


  Int_t nstb=c->Instb;
  Int_t row=c->Row1;
  Int_t col=c->Col1;
  c->fpdcorr->SetValue(2,nstb,row-1,col-1,c->gcorrNew);

  SetFPD(c->fpdcorr);// Hard set values override correction
  c->gcorrNew= c->fpdcorr->GetValue(2,nstb,row-1,col-1);
  

  char setvalchar[100];
  sprintf(setvalchar,"SetValue(2,%d,%d,%d,%f)\n",nstb,row-1,col-1,c->gcorrNew);
  FILE* fp=fopen("ChangeFpd.txt","a");
  if(fp)
    {
      fputs(setvalchar,fp);
      fclose(fp);
      printf("wrote: %s \n",setvalchar);
    }
  else
    {
      printf("failed to write: %s \n",setvalchar);

    };



  c1->Clear();
  fl.cd();

  fl.Purge();
  fl.Close();
  return;
};
