{
  gROOT->Macro("start.C");
  AnalTools at;
  TCanvas* c2=new TCanvas("c2","c2",800,600);
  TCanvas* c1=new TCanvas("c1","c1",800,600);
  TFile f("Output95_4.root");
  TTree* TwoTr=f.Get("TwoTr");
  Int_t nbins=10 ;
  TH1F* M12uN=new TH1F("M12uN","uN",nbins,0,2.);
  TH1F* M12dN=new TH1F("M12dN","dN",nbins,0,2.);
  TH1F* M12uS=new TH1F("M12uS","uN",nbins,0,2.);
  TH1F* M12dS=new TH1F("M12dS","dN",nbins,0,2.);
  TString cuts1="abs(Eta-3.7)<.3&& abs(E12-40)<20&&N12==2";
  TString cuts1="abs(Eta-3.7)<.2&& abs(E12-145)<25";

  TString cuts=cuts1;
  TString North="&&cos(Phi)<-.5";
  TString South="&&cos(Phi)>.5";
  TString Bdown="&&abs(spin-.5)<.6";
  TString Bup="&&abs(spin-1.5)<.6";
  TString Ydown="&&spin<4&&(spin%2==0)";
  TString Yup="&&spin<4&&(spin%2==1)";
  TString dn=Bdown;
  TString up=Bup;
  TwoTr->Project("M12uN","M12",cuts+North+dn);
  M12uN->SetLineColor(1);
  TwoTr->Project("M12dN","M12",cuts+North+up);
  M12dN->SetLineColor(2);
  M12uN->Draw("e");
  M12dN->Draw("esame");
  M12uN->Sumw2();  

  M12dN->Sumw2();
  TH1F* RN=new TH1F((*M12uN)/(*M12dN));
  TwoTr->Project("M12uS","M12",cuts+South+dn);
  M12uS->SetLineColor(3);
  TwoTr->Project("M12dS","M12",cuts+South+up);
  M12dS->SetLineColor(4);
  M12uS->Draw("esame");
  M12dS->Draw("esame");
  M12uS->Sumw2();
  M12dS->Sumw2();
  c2->cd();
  TH1F* RS=new TH1F((*M12uS)/(*M12dS));
  RN->Draw("e");
  RS->SetLineColor(4);
  RS->Draw("esame");
  TH1F* crossR=new TH1F(at.GetCross(M12uN,M12dN,M12uS,M12dS,"CrossRat"));
  TCanvas* c3=new TCanvas("c3","c3",800,600);
  TString ctit="Cross Ratio: ";
  ctit=ctit+cuts;
  crossR->SetTitle(ctit);
  crossR->GetXaxis()->SetTitle("Mass (GeV)");
  crossR->GetYaxis()->SetTitle("raw cross An");
  crossR->Draw();
  c3->Print("cr_M_E145.ps");
  system("ps2pdf cr_M_E145.ps");

}
