{
  gROOT->Macro("start.C");
  Int_t cutnumber=1;
  TString CutNum=gSystem->Getenv("Cut");
  Int_t nn;
  if(CutNum!="")
    {
      sscanf((const char*) CutNum,"%d",&nn);
      cutnumber=nn;
      printf("nn=%d \n",nn);
    };
  
  Int_t nbins=32;
  char dirname[200];
  Long_t pathmask=0x1FE;
  TString PathMask=gSystem->Getenv("PathMask");
  if(PathMask!="")
    {
      sscanf((const char*) PathMask,"%lx",&pathmask);
    };
  TString Fill[10];
  TString SFill[10];
  Fill[0]="";
  Fill[1]="&&Rnum>=12095005 &&Rnum<=12095023";
  Fill[2]="&&Rnum>=12095037 &&Rnum<=12095064";
  SFill[0]="";
  SFill[1]="_Fill15397";
  SFill[2]="_Fill15399";
  Int_t fcutnumber=0;
  sprintf(dirname,"DirCcut%dset%lx_nb%d_f%d",cutnumber,pathmask,nbins,fcutnumber);
  printf("%s \n",dirname);
  gROOT->Macro("CommonSpin.C");

  TH1F* cPhiu=new TH1F("cPhiu","u",nbins,-1,1);
  TH1F* cPhid=new TH1F("cPhid","d",nbins,-1,1);

  TString cuts0="abs(Eta-3.3)<.7&&N12==1 &&abs(E12-70)<25";
  TString cuts1="abs(Eta-3.3)<.7&&N12==1&&Ntracks==1 &&abs(E12-90)<40";
  TString cuts2="abs(Eta-3.3)<.7&&N12==1&&Ntracks==2 &&abs(E12-90)<40&&abs((2*E12-NE)/NE-.4)<.4&&cos(Phi-Phiaway)<.0";
  TString cuts3="abs(Eta-3.3)<.7&&N12>2&&Ntracks==N12 &&abs(EC12-90)<50";
  TString cuts4="abs(Eta-3.3)<.7&&N12>2&&Ntracks==N12 &&abs(EC12-90)<50&&abs(M12>.25)&&abs(abs(cos(Phi))-.5)<.25";
  TString cuts5="abs(Eta-3.3)<.7&&N12>2&&Ntracks==N12 &&abs(EC12-90)<50&&abs(M12>.25)&&(cos(Phi1)-cos(Phi))<0&&abs(abs(cos(Phi))-.5)<.25";

  TString cuts6="abs(Eta-3.3)<.7&&N12>2&&Ntracks==N12 &&abs(EC12-90)<50&&abs(M12>.25)&&(cos(Phi1)-cos(Phi))>0&&abs(abs(cos(Phi))-.5)<.25";
  TString cuts7="abs(Eta-2.9)<.25&&N12==1 &&abs(E12-70)<30";
  TString cuts8="abs(Eta-2.9)<.25&&N12>1 &&abs(E12-100)<30";
  TString cuts9="abs(Eta-3.3)<.7&&N12==2&&Ntracks==N12 &&abs(EC12-110)<50&&abs(MC12-1.)<.5&&abs(abs(cos(Phi))-.5)<.4&&Z>.7";

  TString cutlist[20];
  cutlist[0]=cuts0;
  cutlist[1]=cuts1;
  cutlist[2]=cuts2;
  cutlist[3]=cuts3;
  cutlist[4]=cuts4;
  cutlist[5]=cuts5;
  cutlist[6]=cuts6;
  cutlist[7]=cuts7;
  cutlist[8]=cuts8;
  cutlist[9]=cuts9;
  TString cuts=cutlist[cutnumber]+Fill[fcutnumber];
  TString North="&&cos(Phi)<-.5";
  TString South="&&cos(Phi)>.5";
  TString Bdown="&&abs(spin-.5)<.6";
  TString Bup="&&abs(spin-2.5)<.6";
  TString Ydown="&&spin<4&&(spin%2==0)";
  TString Yup="&&spin<4&&(spin%2==1)";
  TString dn=Bup;
  TString up=Bdown;

  TwoTr->Project("cPhiu","cos(Phi)",cuts+up);
  cPhiu->SetLineColor(1);
  TwoTr->Project("cPhid","cos(Phi)",cuts+dn);
  cPhid->SetLineColor(2);
  cPhiu->Draw("e");
  cPhid->Draw("esame");
  cPhiu->Sumw2();  

  cPhid->Sumw2();
  TH1F* RN=new TH1F((*cPhiu)/(*cPhid));
  c1->SetTitle("Up=blk Dn=red ");
  c2->cd();
  c2->SetTitle("U/D_N=blk");
  RN->Draw("e");
  //  TH1F* crossR=new TH1F(at.GetCross(cPhiuS,cPhidS,cPhiuN,cPhidN,"CrossRat"));
  TH1F* asm=new TH1F(at.GetAsm(cPhiu,cPhid,"Asm"));
  TCanvas* c3=new TCanvas("c3","c3",800,600);
  TString ctit="Asymmetry: ";
  ctit=ctit+cuts+SFill[fcutnumber];
  asm->SetTitle(ctit);
  asm->GetXaxis()->SetTitle("cos(Phi) (GeV)");
  asm->GetYaxis()->SetTitle("raw  An");
  gStyle->SetOptFit();
  asm->Fit("pol1","","",-1,1);
  asm->Draw();
  c1->Write();
  c2->Write();
  c3->Write();
  asm->Write();
  RN->Write();
  cPhiu->Write();
  cPhid->Write();
  fout.cd("../");
  /* usage example
TFile fout("fout.root");
TH1F* h=(TH1F*) ((TDirectory*)fout.Get("DirCcut0set56nb32"))->Get("Asm");h->Draw()
  */

}
