{
  gROOT->Macro("start.C");
  Int_t cutnumber=7;
  Int_t nbins=32;
  char dirname[200];
  Int_t pathmask=0x78;
  sprintf(dirname,"Dirdthycut%dset%dnb%d",cutnumber,pathmask,nbins);
  printf("%s \n",dirname);

  gROOT->Macro("CommonSpin.C");

  TH1F* dthy=new TH1F("dthy","uN",nbins,-.02,.02);
  TH1F* dthyu=new TH1F("dthyu","uN",nbins,-.02,.02);
  TH1F* dthyd=new TH1F("dthyd","dN",nbins,-.02,.02);
  TH1F* dthyN=new TH1F("dthyN","N",nbins,-.02,.02);
  TH1F* dthyS=new TH1F("dthyS","S",nbins,-.02,.02);
  TH1F* dthyuN=new TH1F("dthyuN","uN",nbins,-.02,.02);
  TH1F* dthydN=new TH1F("dthydN","dN",nbins,-.02,.02);
  TH1F* dthyuS=new TH1F("dthyuS","uS",nbins,-.02,.02);
  TH1F* dthydS=new TH1F("dthydS","dS",nbins,-.02,.02);
  
  
  TString cutlist[10];
  for(int jj=0;jj<10;jj++)cutlist[j]="";
  cutlist[0]="abs(Eta-3.3)<.7&&N12>2&&Ntracks==N12 &&abs(EC12-90)<50&&abs(M12)>.25&&abs(abs(cos(Phi))-.5)<.4";
  cutlist[1]="abs(Eta-3.3)<.7&&N12>2&&Ntracks==N12 &&abs(EC12-90)<50&&abs(M12)<.2&&abs(abs(cos(Phi))-.5)<.4";
  cutlist[2]="abs(Eta-3.3)<.7&&N12==2&&Ntracks==N12 &&abs(EC12-90)<50&&abs(MC12)>.2&&abs(abs(cos(Phi))-.5)<.4";
  cutlist[3]="abs(Eta-3.3)<.7&&N12==2&&Ntracks==N12 &&abs(EC12-90)<50&&abs(MC12)<.2&&abs(abs(cos(Phi))-.5)<.4";
  cutlist[4]="abs(Eta-3.3)<.7&&N12==2&&Ntracks==N12 &&abs(EC12-90)<50&&abs(MC12)-.2<.2&&abs(abs(cos(Phi))-.5)<.4";
  cutlist[5]="abs(Eta-3.3)<.7&&N12==2&&Ntracks==N12 &&abs(EC12-90)<50&&abs(MC12)>.7&&abs(abs(cos(Phi))-.5)<.4";
  cutlist[6]="abs(Eta-3.3)<.7&&N12==2&&Ntracks==N12 &&abs(EC12-110)<50&&abs(MC12)>.7&&abs(abs(cos(Phi))-.5)<.4";
  cutlist[7]="abs(Eta-3.3)<.7&&N12==2&&Ntracks==N12 &&abs(EC12-110)<50&&abs(MC12-1.6)<.9&&abs(abs(cos(Phi))-.5)<.4&&Z>.7";
  cutlist[8]="abs(Eta-3.3)<.7&&N12==2&&Ntracks==N12 &&abs(EC12-110)<50&&abs(MC12-1.)<.5&&abs(abs(cos(Phi))-.5)<.4&&Z>.7";
  TString cuts=cutlist[cutnumber];
  TString North="&&cos(Phi)<-.5";
  TString South="&&cos(Phi)>.5";
  TString North0="&&cos(Phi)<0";
  TString South0="&&cos(Phi)>0";

  TString Bdown="&&abs(spin-.5)<.6";
  TString Bup="&&abs(spin-2.5)<.6";
  TString Ydown="&&spin<4&&(spin%2==0)";
  TString Yup="&&spin<4&&(spin%2==1)";
  TString dn=Bup;
  TString up=Bdown;
  TwoTr->Project("dthy","dthy",cuts);
  TwoTr->Project("dthyu","dthy",cuts+up);
  TwoTr->Project("dthyd","dthy",cuts+dn);

  TwoTr->Project("dthyuN","dthy",cuts+North+up);
  dthyuN->SetLineColor(1);
  TwoTr->Project("dthydN","dthy",cuts+North+dn);
  dthydN->SetLineColor(2);
  dthyuN->Draw("e");
  dthydN->Draw("esame");
  dthyuN->Sumw2();  

  dthydN->Sumw2();
  TH1F* RN=new TH1F((*dthyuN)/(*dthydN));
  TwoTr->Project("dthyuS","dthy",cuts+South+up);
  dthyuS->SetLineColor(3);
  TwoTr->Project("dthydS","dthy",cuts+South+dn);

  TwoTr->Project("dthyN","dthy",cuts+North0);
  dthyN->SetLineColor(2);
  dthyS->SetLineColor(3);

  TwoTr->Project("dthyS","dthy",cuts+South0);
  dthydS->SetLineColor(4);
  dthyuS->Draw("esame");
  dthydS->Draw("esame");
  dthyuS->Sumw2();
  dthydS->Sumw2();
  c1->SetTitle("UpN=blk  UpS=grn DnN=red DnS=blue");
  c2->cd();
  c2->SetTitle("U/D_N=blk  U/D_S=blue");
  TH1F* RS=new TH1F((*dthyuS)/(*dthydS));
  RN->Draw("e");
  RS->SetLineColor(4);
  RS->Draw("esame");
  TH1F* crossR=new TH1F(at.GetCross(dthyuS,dthydS,dthyuN,dthydN,"CrossRat"));
  TCanvas* c3=new TCanvas("c3","c3",800,600);
  TString ctit="Cross Ratio: ";
  ctit=ctit+cuts;
  crossR->SetTitle(ctit);
  crossR->GetXaxis()->SetTitle("dthy (GeV)");
  crossR->GetYaxis()->SetTitle("raw cross An");
  crossR->Draw();
  TH1F* asm=new TH1F(at.GetAsm(dthyu,dthyd,"Asm"));
  TString ctit="Asymmetry: ";
  ctit=ctit+cuts;
  asm->SetTitle(ctit);
  asm->GetXaxis()->SetTitle("dthy");
  asm->GetYaxis()->SetTitle("raw  An");
  asm->Draw();
  c1->Write();
  c2->Write();
  c3->Write();
  crossR->Write();
  asm->Write();
  RN->Write();
  RS->Write();
  dthy->Write();
  dthyu->Write();
  dthyd->Write();
  dthyN->Write();
  dthyS->Write();
  dthyuS->Write();
  dthydS->Write();
  dthydN->Write();
  dthyuN->Write();
  fout.cd("../");
  /* usage example
TFile fout("fout.root");
TH1F* h=(TH1F*) ((TDirectory*)fout.Get("Dirdthycut0set120nb32"))->Get("Asm");h->Draw()
  */

}
