{
  gROOT->Macro("start.C");
  TCanvas* c1=new TCanvas("c1","c1",700,700);
  Geom* p_geom=new Geom(p_files);
  TString Tgc=FMSTXT+"/"+FMSCORR;
  CalibStr* gcor=new CalibStr(9010000,Tgc);
  TFile* GR=new TFile("Graph.root","recreate");
  TFile* RD=new TFile("RunDep.root");
  TList* lst= RD->GetListOfKeys();
  RD->Print();
  system("sleep 10");
  TKey* key=0;
  Int_t nrows[4]={34,34,24,24};
  TIter next(lst);
  int cnt=0;
  TGraphErrors* gr_all=new TGraphErrors;
  int nstb=4;
  int row=18;
  int col=7;
  char allname[200];
  sprintf(allname,"r%d_c%d_%d",row,col,nstb-1);
  gr_all->SetName(allname);
  gr_all->SetTitle(allname);
  gr_all->SetMarkerSize(.1);
  while(key=(TKey*) next())
    {
      RunDepCor* rd=(RunDepCor*) key->ReadObj();
      printf("run=%d\n",rd->RunNumber);
      TGraphErrors* gr=0;
      CellTDep* ct=0;
      ct=rd->Cdep(nstb,row,col);
      if(ct)gr=ct->GetGraph();

      //      c1->Print("CellTDep.ps(");
      cnt++;

      if(gr)
	{
	  int gcnt=gr->GetN();
	  int acnt=gr_all->GetN();
	  Double_t x,y,errx,erry;
	  for(int j=0;j<gcnt;j++)
	    {
	      gr->GetPoint(j,x,y);
	      Int_t ix1=(rd->RunNumber-12000000)/1000;
	      Int_t ix0=-(1000*ix1-(rd->RunNumber-12000000));
	      if(ix0>100)ix0=100;

	      x=1.*ix1+1.*ix0/100.+1.*x/100./2000000.;
	      erry=gr->GetErrorY(j);
	      gr_all->SetPoint(acnt,x,y);
	      gr_all->SetPointError(acnt,0,erry);
	      acnt++;
	      printf("point%d x=%f10.7 y=%f10.7 \n",acnt,x,y);
	    };
	  GR->cd();
	  char nam[300];
	  sprintf(nam,"gr_%s",(const char*) rd->GetName());
	  gr->SetName(nam);
	  gr->SetTitle(nam);
	  gr->Write();
	  gr_all->Write();
	  gr->Draw("A*");
	  c1->Update();
	  c1->Print("CellTDep.ps");
	  GR->Purge();
	};
      if(cnt>50)break;
    };
  c1->Print("CellTDep.ps)");
  system("ps2pdf CellTDep.ps; rm CellTDep.ps");
}
